//
//  ViewController.m
//  JetesFirstCrackme
//
//  Created by Kim David Hauser on 24.07.21.
//

#import "ViewController.h"

@implementation ViewController

NSString *dateString =  @"2021-07-24";

- (void)viewDidLoad {
    [super viewDidLoad];
}

- (void)setRepresentedObject:(id)representedObject {
    [super setRepresentedObject:representedObject];
}

- (void)logMsg2Output: (NSString*)msg{
    _txtLicense.string = [NSString stringWithFormat:@"%@\n%@", _txtLicense.string, msg];
    [_txtLicense scrollRangeToVisible: NSMakeRange(_txtLicense.string.length, 0)];
}

- (void)checkSandwichLic{
    
    NSString *lic = _txtName.stringValue;
    
    int eax = 0;
    NSString *ebx = lic;
    if ([ebx length] == 0x13) {
        NSArray<NSString *> *edi = [ebx componentsSeparatedByString:@"-"];
            if ((([edi count] == 0x4) && ([[edi objectAtIndex:0x0] length] == 0x4)) && ([[edi objectAtIndex:0x1] length] == 0x4)) {
                    if ([[edi objectAtIndex:0x2] length] == 0x4) {
                            if ([[edi objectAtIndex:0x3] length] == 0x4) {
                                    int esi = [[edi objectAtIndex:0x0] intValue];
                                    esi = [[edi objectAtIndex:0x1] intValue] + esi;
                                    NSString *eaxNG = [edi objectAtIndex:0x3];
                                    eax = [eaxNG intValue];
//                                    eax = 0x19c5 - (SAR(esi, 0x2)) == eax ? 0x1 : 0x0;
                                int tmp = (esi / pow(2, 2));
                                int tmp2 = (0x19c5 - tmp);
                                eax = (tmp2 == eax ? 0x1 : 0x0);
                            }
                            else {
                                    eax = 0x0;
                            }
                    }
                    else {
                            eax = 0x0;
                    }
            }
            else {
                    eax = 0x0;
            }
    }
    else {
            eax = 0x0;
    }
    if(eax == 0x1){
        [self logMsg2Output:@"Serial IS VALID"];
    }else{
        [self logMsg2Output:@"Serial IS NOT VALID"];
    }
}

- (IBAction)buttonGenerateLicensePressed:(id)sender {
    NSString *license = @"";
    
    int lowerBound = 0;
    int upperBound = 9;
    int checkSum = 0;
    for (int i = 0; i < 4; i++) {
        if(i < 3){
            NSString *licPart = @"";
            for (int j = 0; j < 4; j++) {
                int rndValue = lowerBound + arc4random() % (upperBound - lowerBound);
                licPart = [NSString stringWithFormat:@"%@%d", licPart, rndValue];
            }
            if(i == 0){
                license = [NSString stringWithFormat:@"%@-", licPart];
            }else{
                license = [NSString stringWithFormat:@"%@%@-", license, licPart];
            }
            if(i < 2){
                checkSum += [licPart intValue];
            }
        }else{
            checkSum = (checkSum / pow(2, 2));
            checkSum = (0x19c5 - checkSum);
            license = [NSString stringWithFormat:@"%@%d", license, checkSum];
        }
    }
    
    [self logMsg2Output:license];
}

- (IBAction)buttonPressed:(id)sender {
    
    [self checkSandwichLic];
    return;
    
    NSString *base64 = _txtLicense.string;
    NSData *decodedData = [[NSData alloc] initWithBase64EncodedString:base64 options:0];
    NSString *decodedString = [[NSString alloc] initWithData:decodedData encoding:NSUTF8StringEncoding];
    
    NSString *hexDecoded = [ViewController decodeStringTo64:decodedString];
    if([hexDecoded hasPrefix: _txtName.stringValue]){
        NSString *subStr1 = [hexDecoded substringFromIndex:_txtName.stringValue.length];
        NSString *subStr2 = [subStr1 substringToIndex:10];
        NSString *subStr3 = [subStr1 substringFromIndex:subStr2.length];
        
        NSDateFormatter *dateFormatter = [[NSDateFormatter alloc] init];
        [dateFormatter setDateFormat:@"yyyy-MM-dd"];
        NSDate *date = [dateFormatter dateFromString:subStr2];
        
        if(date != nil){
            if([subStr2 isEqualToString:dateString]){
                long daLen = _txtName.stringValue.length + 0xa;
                NSString *subStr4 = [NSString stringWithString: subStr3];
                bool hasError = false;
                for (int i = 0; i < daLen * 2; i++) {
                    NSString *currPart = @"";
                    if(i % 2 == 0){
                        currPart = [NSString stringWithFormat:@"%d", i];
                    }else{
                        currPart = [NSString stringWithFormat:@"%c", i + 0x40];
                    }
                    if([subStr4 hasPrefix:currPart]){
                    }else{
                        hasError = true;
                        break;
                    }
                    subStr4 = [subStr4 substringFromIndex:currPart.length];
                }
                if(!hasError){
                    [self licenseIs:true];
                }else{
                    [self licenseIs:false];
                }
            }else{
                [self licenseIs:false];
            }
        }else{
            [self licenseIs:false];
        }
    }else{
        [self licenseIs:false];
    }
}

- (void)licenseIs: (BOOL)isValid{
    if(isValid){
        _lblResult.backgroundColor = NSColor.greenColor;
        _lblResult.stringValue = @"License IS VALID";
    }else{
        _lblResult.backgroundColor = NSColor.redColor;
        _lblResult.stringValue = @"License is NOT VALID";
    }
}
@end
